      FUNCTION RSGG(s,IER)
c <gg> correlation recimbined after isospin and strangeness separation; provides a possible test of the
c flavorseparation when recombined
      IMPLICIT NONE
      INTEGER i,j,jj,ini,IER,iresonances,IRESON,NFext,NFext1,nf,ites
      DOUBLE PRECISION s,E,RS40,RSGG,BW,
     &     null,fac,rbw,rebw,Rinicall,UGM2,sMeV,ELOW,EHIGH,
     &     RSGG1,RGG,R3G,R33,F3G,FGG,RSGGpQCD
      DOUBLE PRECISION res(3),fsta(5),fsys(5)
      REAL*8 EMIPS(6),EMAPS(6),EMIYP(6),EMAYP(6),EOMM,EOMP,EFIM,EFIP
      INTEGER NGG,N
      PARAMETER(NGG=479)
      DOUBLE PRECISION XGG(NGG),YGG(NGG,3)
      DOUBLE PRECISION MOM,GOM,POM,MFI,GFI,PFI
      DOUBLE PRECISION CHPTCUTLOC,ERXYDAT,ECHARMTH,ECUTFIT
      real *8 xc,xb,xt
      real *8 mq(6),mp(6),th(6)
      real *8 rggnf2,rggnf2_alt,r3gnf2,r3gnf2_alt,r33nf2,r33nf2_alt
      COMMON/BWOM/MOM,GOM,POM/BWFI/MFI,GFI,PFI
      COMMON/RESRELERR/FSTA,FSYS
c resonances flag iresonances=1 include resonances as data here; 0 include them
c elsewhere; iresonances=1 Rdat_all.f yields R value including narrow resonances
      COMMON/RES/iresonances
      COMMON/RESFIT/fac,IRESON
c fac converts Breit-Wigner resonance contribution to R value; IRESON dummy here
c IRESON=1 Rdat_fit.f yields R value including narrow resonances
      COMMON/RESDOMAINS/EMIPS,EMAPS,EMIYP,EMAYP,EOMM,EOMP,EFIM,EFIP
      COMMON /RGGDAT/XGG,YGG,N
      external RS40,BW,RSGGpQCD
c      common /rhadparts/ru,rd,rs,rc,rb,rt,rsg,rem
      common /cufit/CHPTCUTLOC,ERXYDAT,ECHARMTH
      common /quama/mq,mp,th
      common /rggnf2special/rggnf2,rggnf2_alt
      common /r3gnf2special/r3gnf2,r3gnf2_alt
      common /r33nf2special/r33nf2,r33nf2_alt
c      data ini /0/
c      if (ini.eq.0) then
************************************************************************
c Set parameters in above common blocks: BWOM,BWFI,PSYPPAR,RESRELERR
c rho, omega, phi, J/psi and Upsilon series
c
         call resonances_data()
c
c called from resonances_dat.f
************************************************************************
         null=0.d0
         UGM2=1.D6
         xc=0.375d0
         xb=0.750d0
         xt=xc
c         ini=1
c      endif
c         write (14,*) ' RSGG in  -- ier=',ier
      J=IER
      sMeV=s*UGM2
      rbw =null
      REBW=null
      do jj=1,3
         res(jj) =null
      enddo
      RSGG1=null
      RSGG1=null
      E=SQRT(S)
      ELOW =XGG(1)                ! 0.318
      EHIGH=XGG(NGG)              ! 2.125
c      EHIGH=2.d0                  ! by convention for LQCD comparison
      CHPTCUTLOC=DMAX1(ELOW,CHPTCUTLOC)  ! do not go below recombined data set RGG0321.f
      ECUTFIT=DMAX1(EHIGH,ERXYDAT)       ! exhaust recombined data set RGG0321.f
      ECUTFIT=EHIGH
      ECHARMTH=th(4)  ! 4.2 GeV
      RSGG=null
      ites=0
      IF (E.LE.ELOW) THEN
         RSGG=RS40(s,J)
c         write (14,*) ' RSGG out-1  -- ier=',ier
         RETURN
      ENDIF
      if ((E.GT.ELOW).and.(E.LE.EHIGH)) then
         call getindex(E,NGG,XGG,I)
         if (I.LT.NGG) then
            res(j)=YGG(I,j)+(YGG(I+1,j)-YGG(I,j))
     &           /(XGG(I+1)-XGG(I))*(E-XGG(I))
            if (j.eq.3) then
               res(j)=res(j)*(YGG(I,1)+(YGG(I+1,1)-YGG(I,1))
     &              /(XGG(I+1)-XGG(I))*(E-XGG(I)))
            endif
         else
            res(j)=YGG(NGG,j)
            if (j.eq.3) then
               res(j)=res(j)*YGG(NGG,1)
            endif
         endif
         if (iresonances.eq.1) then
            if ((E.GT.EOMM).and.(E.LT.EOMP)) then
               rbw=fac*BW(sMeV,MOM,GOM,POM)
               if (ier.eq.2) then
                  rbw=rbw*fsta(2)
                  res(j)=sqrt(res(j)**2+rbw**2)
               else 
                  if (ier.eq.3) rbw=rbw*fsys(2)
                  res(j)=res(j)+rbw
               endif
               rebw=rbw
            endif
c phi   1.00D0,1.04D0
            if ((E.GT.EFIM).and.(E.LT.EFIP)) then
               rbw=fac*BW(sMeV,MFI,GFI,PFI)
               if (ier.eq.2) then
                  rbw=rbw*fsta(3)
                  res(j)=sqrt(res(j)**2+rbw**2)
               else 
                  if (ier.eq.3) rbw=rbw*fsys(3)
                  res(j)=res(j)+rbw
               endif
               rebw=rbw
            endif
         endif
         RSGG=res(j)
c         write (14,*) ' RSGG out-2  -- ier=',ier
         RETURN
      endif
      IF (E.GE.EHIGH) THEN
c test wether EHIGH is actually set rahd produces a stop if E < 1.8 GeV set by TH(3)
         if (E.LT.1.8d0) write (*,*) ' RSGG: pQCD call, E,EHIGH',E,EHIGH
         RSGG=RS40(s,J)
c         RSGG=RSGGpQCD(s,J)
c         write (14,*) ' RSGG out-3  -- ier=',ier
         RETURN
      ENDIF
      END
c
      FUNCTION RSGGpQCD(s,IER)
c note: in data RSGG=1/2 RS3G =RS33 we must normalize it correspondingly 
      implicit none
      integer  IER,IOR,NF,ICHK,IOR1,NF1
      real *8 s,R,RSpQCD,RSGGpQCD,ALINP,EINP,MTOP,pi,
     &        ALS,EST,ESY,MZINP,ALINP1,MTOP1,RSP,RSM
      real *8 res(3)
      COMMON/QCDPA/ALS,EST,ESY,MZINP,MTOP,NF,IOR,ICHK ! global INPUT from main
      common/pqcdHS/pi,ALINP1,EINP,MTOP1,IOR1,NF1 ! local input for Rhad HS etc
      external RSpQCD
      EINP =MZINP
      MTOP1=MTOP
      IOR1 =IOR
      NF1  =NF
      RSGGpQCD=RSpQCD(s,IER)
      return
      end
