#!/bin/csh -fx

make

echo ' run  alphaQEDc19'
time ./alphaQEDc19 

echo "Results in fort.1,2,3,4 ..."

cat alphaQEDgnuplot.in > alphaQEDplot_gnu.in
cat >> alphaQEDplot_gnu.in <<_EOF_
set ylabel "{/Symbol D}{/Symbol a}(E)" 
plot "fort.1" skip 5 using 1:2 with lines ls 1 t "leptons+hadrons", '' skip 5 using 1:3 with lines ls 1 t "", '' skip 5 using 1:4 with lines ls 1 t "",\
  "fort.4" skip 5 using 1:2 with lines ls 3 t "leptons", '' skip 5 using 1:3 with lines ls 2 t "had^{(5)}", '' skip 5 using 1:4 with lines ls 4 t "top"
pause -1
clear
_EOF_

gnuplot -persist alphaQEDplot_gnu.in
#> alphagnu1.eps

echo -n "Next figure? press RETURN"
set ans1=$<

cat alphaQEDgnuplot.in > alphaQEDplot_gnu.in
cat >> alphaQEDplot_gnu.in <<_EOF_
set ylabel "{/Symbol a}(E)" 
plot "fort.2" skip 5 using 1:2 with lines ls 1 t "leptons+hadrons", '' skip 5 using 1:3 with lines ls 1 t "", '' skip 5 using 1:4 with lines ls 1 t ""
pause -1
clear
_EOF_

gnuplot alphaQEDplot_gnu.in 
#> alphagnu2.eps

echo -n "Next figure? press RETURN"
set ans1=$<
cat alphaQEDgnuplot.in > alphaQEDplot_gnu.in
cat >> alphaQEDplot_gnu.in <<_EOF_
set ylabel "Im {/Symbol D}{/Symbol a}(E)" 
plot "fort.11" skip 5 using 1:2 with lines ls 1 t "leptons+hadrons", '' skip 5 using 1:3 with lines ls 1 t "", '' skip 5 using 1:4 with lines ls 1 t "",\
  "fort.14" skip 5 using 1:2 with lines ls 3 t "leptons", '' skip 5 using 1:3 with lines ls 2 t "had^{(5)}", '' skip 5 using 1:4 with lines ls 4 t "top"
pause -1
clear
_EOF_

gnuplot alphaQEDplot_gnu.in 
#> alphagnu1.eps

echo -n "Next figure? press RETURN"
set ans1=$<

cat alphaQEDgnuplot.in > alphaQEDplot_gnu.in
cat >> alphaQEDplot_gnu.in <<_EOF_
set ylabel "Im {/Symbol a}(E)" 
plot "fort.12" skip 5 using 1:2 with lines ls 1 t "leptons+hadrons", '' skip 5 using 1:3 with lines ls 1 t "", '' skip 5 using 1:4 with lines ls 1 t ""
pause -1
clear
_EOF_

gnuplot alphaQEDplot_gnu.in 
#> alphagnu2.eps

echo -n "Next figure? press RETURN"
set ans1=$<

exit 0
usage:
alphaQEDc17_gnu.sh
exit 2

