c;;;;;;;;;;;;;;;;;;;;;;;;;;;;; -*- Mode: Fortran -*- ;;;;;;;;;;;;;;;;;;;;;;;;;;;
c;; funalp2sm.f --- 
c;; Author          : Friedrich Jegerlehner
c;; Created On      : Sun Jan 17 05:35:18 2010
c;; Last Modified By: Friedrich Jegerlehner
c;; Last Modified On: Tue Jul 18 03:37:52 2017
c;; RCS: $Id$
c;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c;; Copyright (C) 2010 Friedrich Jegerlehner
c;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c;; 
      function funalp2SMrx(s,error,errorsta,errorsys,contributionflag)
      implicit none
      character*3 contributionflag
      real*8 funalp2SMrx,degvapx,s,error,errorsta,errorsys
      real*8 st2,als,mtop,alp2
      real*8 dglept,dghadr,dgetop,dvpt_new,dvpt_hig,dvpt_low
      real*8 alpha2c,alpha2h,alpha2l,alpha2ct,alpha2ht,alpha2lt,
     &     Dalpha2weak1MSb,
     &     errdeg,errdegsta,errdegsys
********************* part to be included and edited in main program **************
c decommment next line in main
c      double precision pi1,ALINP,ERRAL,EINP,MTOP1 ! get QCD parameters as set in constants_qcd
c some QCD parameters required to calculare top contribution 
      include 'common.h'      
c decommment next 2 lines in main
c      common/var1/pi1,ALINP,ERRAL,EINP,MTOP1
      common /parm/st2,als,mtop
      common /resg/dglept,dghadr,dgetop,Dalpha2weak1MSb 
c decommment next 2 lines in main
c      call constants()
c      call constants_qcd()
c      sin2ell=0.23153 ! pm 0.00016 LEPEEWG Phys Rep 427 (2006) 257
c decommment next line and change default as appropriate in main      
c      st2=0.23153d0   ! Reference value for weak mixing parameter
c decommment next 2 lines in main
c      als=ALINP       ! alpha strong
c      mtop=MTOP1      ! top quark mass
C LEPTONflag=all,had,lep,ele,muo,tau -> iLEP=-3,-2,-1,1,2,3
C Default: 
C      LEPTONflag='all'
C      iLEP  = -3  ! for sum of leptons + quarks              
C decomment in main the following 2 lines for changing the default
c      LEPTONflag='all'   ! choose had,lep,top,ele,muo,tau
c      iLEP=LFLAG(LEPTONflag)
************************************************************************
      LEPTONflag=contributionflag
      iLEP=LFLAG(LEPTONflag)
      alp2=alp/st2
      dvpt_new= degvapx(s,errdeg,errdegsta,errdegsys)
      dvpt_hig= dvpt_new+errdeg
      dvpt_low= dvpt_new-errdeg
      alpha2c=alp2/(1.d0-dvpt_new)
      alpha2h=alp2/(1.d0-dvpt_hig)
      alpha2l=alp2/(1.d0-dvpt_low)
      alpha2ct=alp2/(1.d0-dvpt_new-dgetop-Dalpha2weak1MSb)
      alpha2ht=alp2/(1.d0-dvpt_hig-dgetop-Dalpha2weak1MSb)
      alpha2lt=alp2/(1.d0-dvpt_low-dgetop-Dalpha2weak1MSb)
      error=abs((alpha2h-alpha2l))/2.d0
      errorsta=alpha2c/alp2*alpha2c*errdegsta
      errorsys=alpha2c/alp2*alpha2c*errdegsys
      funalp2SMrx=alpha2ct
      return
      END
