c;;;;;;;;;;;;;;;;;;;;;;;;;;;;; -*- Mode: Fortran -*- ;;;;;;;;;;;;;;;;;;;;;;;;;;;
c;; funalpqed.f --- 
c;; Author          : Friedrich Jegerlehner
c;; Created On      : Sun Jan 17 05:35:18 2010
c;; Last Modified By: Friedrich Jegerlehner
c;; Last Modified On: Tue Jul 18 03:12:59 2017
c;; RCS: $Id$
c;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c;; Copyright (C) 2010 Friedrich Jegerlehner
c;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c;; 
      function funalpqedrx(s,error,errorsta,errorsys,contributionflag)
      implicit none
      character*3 contributionflag
      double precision funalpqedrx,s,error,errorsta,errorsys
      double precision dggvapx,errder,errdersta,errdersys,
     &     dalept,dahadr,daltop,Dalphaweak1MSb
      double precision dvpt_new,dvpt_hig,dvpt_low,
     &     alphac,alphah,alphal,alphact,alphaht,alphalt
      external dggvapx
********************* part to be included and edited in main program **************
c decommment next line in main
c      double precision pi1,ALINP,ERRAL,EINP,MTOP1 ! get QCD parameters as set in constants_qcd
c some QCD parameters required to calculare top contribution 
      include 'common.h'      
c decommment next 2 lines in main
c      common/var1/pi1,ALINP,ERRAL,EINP,MTOP1
c      common /parm/st2,als,mtop
      common /resu/dalept,dahadr,daltop,Dalphaweak1MSb
c decommment next 2 lines in main
c      call constants()
c      call constants_qcd()
c      sin2ell=0.23153 ! pm 0.00016 LEPEEWG Phys Rep 427 (2006) 257
c decommment next line and change default as appropriate in main      
c      st2=0.23153d0   ! Reference value for weak mixing parameter
c decommment next 2 lines in main
c      als=ALINP       ! alpha strong
c      mtop=MTOP1      ! top quark mass
C LEPTONflag=all,had,lep,ele,muo,tau -> iLEP=-3,-2,-1,1,2,3
C Default: 
C      LEPTONflag='all'
C      iLEP  = -3  ! for sum of leptons + quarks              
C decomment in main the following 2 lines for changing the default
c      LEPTONflag='all'   ! choose had,lep,top,ele,muo,tau
c      iLEP=LFLAG(LEPTONflag)
************************************************************************
      LEPTONflag=contributionflag
      iLEP=LFLAG(LEPTONflag)
      dvpt_new= dggvapx(s,errder,errdersta,errdersys)
      dvpt_hig= dvpt_new+errder
      dvpt_low= dvpt_new-errder
      alphac =alp/(1.d0-dvpt_new)
      alphah =alp/(1.d0-dvpt_hig)
      alphal =alp/(1.d0-dvpt_low)
      alphact=alp/(1.d0-dvpt_new-daltop-Dalphaweak1MSb)
      alphact=alp/(1.d0-dvpt_new-daltop-Dalphaweak1MSb)
      alphaht=alp/(1.d0-dvpt_hig-daltop-Dalphaweak1MSb)
      alphalt=alp/(1.d0-dvpt_low-daltop-Dalphaweak1MSb)
      error=abs((alphah-alphal))/2.d0
      errorsta=alphac/alp*alphac*errdersta
      errorsys=alphac/alp*alphac*errdersys
      funalpqedrx=alphact
      return
      END
