      subroutine hadrK3cdist19(e,dk3c,errdk3c)
      IMPLICIT NONE
      INTEGER NB,IJ,I,ini
      PARAMETER(NB=2174)
      real e,dk3c,errdk3c
      real dal(2)
      REAL ESA(NB),DAS(NB,2)
      COMMON /DK3C19/ESA,DAS
      data ini/0/
C initialize data

      call k3chad_timelike19

      if (e.eq.0.0) then
        dk3c=0.0
        errdk3c=0.0
        return
      else if ((e.ge.ESA(1)).and.(e.le.ESA(NB))) then
        ij=NB
        do while (ESA(ij).gt.e)
          ij=ij-1
        enddo
        DO I=1,2
        dal(i)=DAS(IJ,I)
     &    +(DAS(IJ+1,I)-DAS(IJ,I))/(ESA(IJ+1)-ESA(IJ))*(E-ESA(IJ))
        ENDDO
        dk3c=dal(1)
        errdk3c=dal(2)
        return
      else 
         dk3c=0.0
         errdk3c=0.0
         if (ini.le.10) then
            write(*,*) ' out of range! e=',e
            ini=ini+1
            if (ini.eq.10) write(*,*) ' Warning: continuing anyway ...'
         endif
      endif
      return
      end

       subroutine dhadrK3cdist19(de,ddk3c,derrdk3c)
c **********************************************************************
c *    F. Jegerlehner, University of Silesia, PL-40007 Katowice, Poland *
c **********************************************************************
c Converts hadrK3cdist14 to double precision variables in dhadrK3cdist14
c
       implicit none
       real *8 de,ddk3c,derrdk3c
       real    se,sdk3c,serrdk3c
       se=real(de)
       call hadrK3cdist15(se,sdk3c,serrdk3c)
       ddk3c    =dble(sdk3c)
       derrdk3c=dble(serrdk3c)
       return
       end
c
c Following datasets obtained with run parameters specified in the header
c
      include 'k3chadslow19.f'

      save
      RETURN
      END
