C#	$Id: rqcd3.f,v 1.3 1996/05/19 00:17:09 fjeger Exp $	
      subroutine rqcd3(s,R,ALINP,EINP,MTOP,FTQ,IOR,NF)
Calculation of R-value to 3-loop      
C link QCDPAR1 to get running parameters
      implicit none
      integer  NFX,FTQ,IOR,ini,NF
      real *8 s,R,ALINP,EINP,MTOP,AL,E
      real *8 pi,adp,r1,r2,Qrat,R0,R04,R05,betac,betab,betat,sx
      real *8 adp2,adp3,epadp0,epadp,epadpc,cx,xc,zeta2,mc2,mb2
      REAL *8 MQ(6),MP(6),TH(6)
      data pi /3.141592653589793d0/
      COMMON /QUARK/MQ,MP,TH
      data ini/0/

       call rqcdparam()   ! fill make sure QUARK has standard values

      zeta2=pi**2/6.d0
      R04  =10.d0/3.d0
      R05  =11.d0/3.d0
      E=dsqrt(s)
      sx=s
      if (E.LT.TH(3)) then
         R=5.d0/3.d0
c         write (*,*) ' R_QCD=5/3 for E < 1 GeV used! '
         return
      elseif (E.LE.TH(4)) then
         R=2.d0   ! lowest order estimate
c         write (*,*) ' R_QCD= 2  for 1 < E < 3.1 GeV used! '
         return
      endif
      if (IOR.GT.0) then
        call ALQCD2(sx,ALINP,EINP,MTOP,AL,nfx,FTQ,IOR)
      endif
      adp=al/pi
      adp2=adp**2
      adp3=adp2*adp
      epadp0=1.d0+adp
      cx =4.d0*pi*al/3.d0
      if (E.LE.TH(5)) then
         Qrat=2.d0/9.d0
C c quark threshold factor
         mc2=1.8d0**2
         betac=0.d0
         epadpc=1.d0
         if (E.GT.3.6D0) then
           betac=dsqrt(1.d0-4.d0*mc2/s)
           xc  =cx/betac
           epadp=xc/(1.d0-dexp(-xc))-(3.d0+betac)*(zeta2-0.25d0)*adp
           epadpc=epadp/epadp0
         endif 
         R0  =2.d0+4.d0/3.d0*betac*(3.d0-betac**2)/2.d0
C      elseif (E.LE.2.D0*MTOP) then
      else 
         Qrat=1.d0/33.d0
C b quark threshold factor
         mb2=5.0d0**2
         betab=0.d0
         epadpc=1.d0
         if (E.GT.10.D0) then
           betab=dsqrt(1.d0-4.d0*mb2/s)
           xc  =cx/betab
           epadp=xc/(1.d0-dexp(-xc))-(3.d0+betab)*(zeta2-0.25d0)*adp
           epadpc=epadp/epadp0
         endif
         R0  =R04+1.d0/3.d0*betab*(3.d0-betab**2)/2.d0
C      else
C         Qrat=3.d0/15.d0
CC t quark threshold factor
C         betat=0.d0
C         if (E.GT.2.D0*MTOP) betat=dsqrt(1.d0-4.d0*MTOP**2/s)
C         R0  =R05+4.d0/3.d0*betat*(3.d0-betat**2)/2.d0
      endif
      if ((NF.EQ.6).and.(E.GT.2.D0*MTOP) ) then
         Qrat=3.d0/15.d0
C t quark threshold factor
         betat=0.d0
         epadpc=1.d0
         if (E.GT.2.D0*MTOP) then
           betat=dsqrt(1.d0-4.d0*MTOP**2/s)
           xc  =cx/betat
           epadp=xc/(1.d0-dexp(-xc))-(3.d0+betat)*(zeta2-0.25d0)*adp
           epadpc=epadp/epadp0
         endif
         R0  =R05+4.d0/3.d0*betat*(3.d0-betat**2)/2.d0
      endif
      r1= 1.9857d0-0.1153d0*nfx
      r2=-6.6368d0-1.2002d0*nfx-0.0052d0*nfx**2-1.2395d0*Qrat
      if ((nfx.eq.5).and.(ini.eq.0)) then
        write (*,*) ' nf,c1:',nfx,adp
        write (*,*) '    c2:',r1*adp2
        write (*,*) '    c3:',r2*adp3
        ini=1
      endif 
      if (IOR.eq.0) then
        R=R0
      else if (IOR.eq.1) then
        R=R0*(epadp0)
      else if (IOR.eq.2) then
        R=R0*(epadp0+r1*adp**2)
      else
        R=R0*(epadp0+r1*adp**2+r2*adp**3)      
      endif
      return
      end
