      subroutine resonances_renoreal()
      implicit none
      integer i,j,k,count,Nall,N1,N2
      parameter(Nall=2187)
      REAL *8 X(Nall)
      INTEGER NA,NB
      PARAMETER(NA=979,NB=200)
      REAL ETX(NA),ESX(NB)
      integer nx,ny
      parameter(nx=400,ny=15)
      integer nres(ny),ini_reso_reno_dat
      real*8 dggvapx
      real*8 dvpt_new,dvpt_hig,dvpt_low
      real*8 alphac,alphah,alphal,r1c,r1h,r1l
      double precision null,emin,emax,e,s,rrr,errorn
      double precision reno,renl,renh,error,errorsta,errorsys
      double precision renpts(nx,ny),renofa(nx,ny),fracerr(nx,ny)
c      double precision r1rx(nx,ny)
      REAL*8 EMI(ny),EMA(ny)
      COMMON/RESRAN/EMI,EMA
c      common /renormBW/renpts,renofa,fracerr,r1rx,nres
      common /renormBW/renpts,renofa,fracerr,nres,ini_reso_reno_dat
      external dggvapx
      include 'common.h'
      null=0.d0
      s=2.d0**2

      rrr=dggvapx(s,error,errorsta,errorsys)

      include 'xRdat-extended.f' ! just DATA X/.../ statement
c      
      do j=2,15
         emin=EMI(j)
         emax=EMA(j)
         call getindex(emin,Nall,X,N1)
         call getindex(emax,Nall,X,N2)
c         write (*,*) emin,emax,N1,N2
         count=0
         do 10 i=N1,N2
            count=count+1
            e=X(i)
            s=-e*e 
            dvpt_new= dggvapx(s,error,errorsta,errorsys)
            dvpt_hig= dvpt_new+error
            dvpt_low= dvpt_new-error
            alphac =alp/(1.d0-dvpt_new)
            alphah =alp/(1.d0-dvpt_hig)
            alphal =alp/(1.d0-dvpt_low)
            r1c=alp/alphac
            r1h=alp/alphah
            r1l=alp/alphal
            reno=r1c**2 ! undressing factor
            renh=r1h**2 ! + error
            renl=r1l**2 ! - error11
            errorn=abs((renh-renl)/2.0d0)/reno
            renpts(count,j)=e
            renofa(count,j)=reno
            fracerr(count,j)=errorn
c            r1rx(count,j)=r1c
c            write (*,*) ' resonance_reno:',j,e,reno
 10      continue
         nres(j)=count
      enddo
c      write (*,*) ' resonance_reno:',nres
c     ..................................................................
      return
      end
