      program test_alpsHS
      implicit none
      integer i,ii,n,np,FTQ,IOR,NF,ICHK,IER,nfeff,nf1,nfx
      real *8 pi1,ALINP,EINP,MTOP,alerr
      real *8 mq(6),mp(6),th(6),dmp(6,3)
      real *8 pi,s,e0,de,e,emin,emax,mz,scfac,alphasx,alpha,
     & alpha_arun,alprun,al
      common /inp/pi1,ALINP,EINP,MTOP
      common /int/FTQ,IOR,NF,ICHK
      common /quama/mq,mp,th
      common /QUAME/DMP
      common /QUAER/alerr,IER

      call rqcdparam()

      mz=91.1876d0
      mtop=173.5d0
      ALINP=0.1184d0
      EINP=mz
      pi=pi1
      ICHK=2
      FTQ=0
      NF=5
      IOR=4
      IER=1
      np=150
      do ii=1,3 
         write (ii,*) '     3.0000' 
         write (ii,*) '     1.0000' 
         write (ii,*)       float(np+1) 
      enddo
      emin=mz
      emax=2.d0*mtop+20d0
      emax=300.d0+mz
      de=(emax-emin)/np
      e=emin-de
      write (*,*) ' de=',de
      do i=1,np+1
         e=e+de
         if (i.eq.1) e=mz
         if (i.eq.np+1) e=mtop
         s=e*e
         CALL ALQCD2(s,ALINP,EINP,MTOP,AL,NFX,FTQ,3)
      
         alpha=alphasx(s,nfeff)
         alpha_arun=alprun(s,nf1)
         write (1,*) e,alpha,sqrt(4.d0*pi*alpha),nfeff
         write (2,*) e,alpha_arun,sqrt(4.d0*pi*alpha_arun),nf1
         write (3,*) e,al,sqrt(4.d0*pi*al),nfx
      enddo
      stop
      end

      function alphasx(s,nfeff)
      implicit none
      integer i,FTQ,IOR,IOR1,NF,ICHK,IER,nfeff,nfx
      integer loops, nf1
      real *8 S,ALINP,EINP,MTOP,pi,alerr
      real *8 mq(6),mp(6),th(6),dmp(6,3)
      real*8 ARUN, alpha0, mu0, mu1, Mth(6), muth(6)
      real*8 sqrts, alpha, alphas, alphasx
      common /inp/pi,ALINP,EINP,MTOP
      common /int/FTQ,IOR,NF,ICHK
      common /quama/mq,mp,th
      common /QUAME/DMP
      common /QUAER/alerr,IER
c
      call alpsHS(s,alpha,ALINP,EINP,MTOP,IOR,NFx)
      alphasx=alpha
      nfeff=nfx
c      write (1,*) sqrt(s),alpha,EINP,ALINP
      return
      end

      function alprun(s,nf1)
      implicit none
      integer i,FTQ,IOR,IOR1,NF,ICHK,IER
      integer loops, nf1
      real *8 S,e,PI,ALINP,ERALS,EINP,MTOP,alps
      real *8 mq(6),mp(6),th(6)
      real *8 ARUN, alpha0, mu0, mu1, Mth(6), muth(6)
      real *8 sqrts, alpha, alprun
      common /inp/pi,ALINP,EINP,MTOP
      common /int/FTQ,IOR,NF,ICHK
      common /quama/mq,mp,th
      common /quaer/ERALS,IER
      common /alpha/mu1,alpha
c
      e=sqrt(s)
c  Given: 
c       alpha0(mu0) --- initial value at reference point
c       mu0         --- reference point
c       Mth(1:6)    --- array of thresholds (in On-Shell scheme) 
c       muth(1:6)   --- array of decoupling scales
c       mu1         --- new point
c       loops       --- number of loops (1,2,3,4) 
c       
      do i=1,5 
         Mth(i)  = mp(i)
         muth(i) = th(i)
      enddo
      sqrts=sqrt(s)
      alpha0=alinp
      if (IER.eq.2) alpha0=alinp-ERALS 
      if (IER.eq.3) alpha0=alinp+ERALS 
      mu0   =einp
      loops =ior
      mu1   =sqrts
      alpha = ARUN ( alpha0, mu0, Mth, muth, mu1, loops, nf1 )
      alprun=alpha
      write (*,*) ' alprun:',alpha0,mu0,alpha,mu1
      return
      end
