      program test_rqcdHS
      implicit none
      integer i,n,np,ichk
      real *8 s,r,RS,e0,de,e,emin,emax,mz,scfac,alpha,mtop
      common /alpout/alpha
      ICHK=2
      mz=91.1876d0
      mtop=173.5d0
      scfac=2.1044d0
         e0=5.d0
         de=1.d0
         e=e0
c         np=300
         np=3
         e0=mz
         de=mtop-mz
         e=e0
         np=1
c Graph for gm2buch  R(s) pQCD
         write (1,*) '     3.0000' 
         write (1,*) '     1.0000' 
         write (1,*)       float(np+1) 
         emin=02.5d0
c         emax=13.5d0
         emax=mz*scfac
         emin=e0
         emax=e0+de
c
         de=(emax-emin)/np
      do i=1,np+1 
c      do i=1,301 
c         if (e.gt.9.6d0) de=10.d0
c         if (e.gt.174.d0) de=50.d0
         e=emin+de*(np-1)
         s=e*e
         r=rs(s)
         write (1,*) e,r,alpha
      enddo
      stop
      end

      function RS(S)
      implicit none
      integer i,FTQ,IOR,IOR1,NF,ICHK,IER
      integer loops, nf1, R2, R4
      real *8 S,R,RS,ALINP,EINP,MTOP,pi,alerr
      real *8 mq(6),mp(6),th(6),dmp(6,3)
      real*8 ARUN, alpha0, mu0, mu1, Mth(6), muth(6)
      real*8 Rpt, sqrts, alpha, rv
      common /inp/pi,ALINP,EINP,MTOP
      common /int/FTQ,IOR,NF,ICHK
      common /quama/mq,mp,th
      common /QUAME/DMP
      common /QUAER/alerr,IER
      common /alpout/alpha

      call rqcdparam()

      ior=3
      NF=5
      FTQ=2
c
      if (ICHK.EQ.0) then
c         call rqcd3(S,R,ALINP,EINP,MTOP,FTQ,IOR,NF) 
      else if (ICHK.EQ.1) then
c         call rqcd3m(s,R,ALINP,EINP,MTOP,FTQ,IOR,NF)
      else if (ICHK.EQ.2) then
c        call rqcd3mn(s,R,ALINP,EINP,MTOP,FTQ,IOR,NF)
        call rqcdHS(s,R,ALINP,EINP,MTOP,FTQ,IOR,NF)
      else
c  Given: 
c       alpha0(mu0) --- initial value at reference point
c       mu0         --- reference point
c       Mth(1:6)    --- array of thresholds (in On-Shell scheme) 
c       muth(1:6)   --- array of decoupling scales
c       mu1         --- new point
c       loops       --- number of loops (1,2,3,4) 
c       
         do i=1,6 
           Mth(i)  = mp(i)
           muth(i) = th(i)
         enddo
         sqrts=sqrt(s)
         alpha0=alinp
         mu0   =einp
         loops =ior
         mu1   =sqrts
         alpha = ARUN ( alpha0, mu0, Mth, muth, mu1, loops, nf1 )

c  Arguments:
c     sqrts = sqrt(s)  (in GeV)
c             must be > 10.0 GeV
c     alpha = alpha(s)
c             note that mu=s in the following
c             therefore alpha should be taken as alpha(s)
c     loops = 1,...,4
c             1 correspond to parton model (no QCD corr.)
c             4 QCD corr. to O(alpha^3)
c
c      R2, R4 = 0 or 1
c        we have further two parameter R2 and R4 to 
c        swich on/off mm and mm^2 corections correspondingly.
        r2=1
        r4=1
        R =Rpt( sqrts, alpha, loops, R2, R4 )
      endif
      RS=R
      return
      end
