      program test_rqcdHS
      implicit none
      integer i,j,FTQ,IOR,NF,ICHK,IER,N,imu,imc,imb,iord,
     &     NFext,NFext1,nf1
      real *8 pi,ALINP,ERALS,ERRAL,EINP,MTOP,mu,alpha,le0,le1,le,dle,
     &     sqrts,api,alpha_s
      real *8 mq(6),mp(6),th(6),mcin(3),mbin(3),muin(3)
      real *8 s,RS,e0,emin,emax,de,e,r(3),als(3)
      real *8 muinp,mp4inp,mp5inp,rx
      real *8 massc,massb,masst,mc,mb,mt,dummy,scms
      real *8 Rvec,Raxi,Rqed,Rless
      real *8 ru1,rd1,rs1,rc,rb,rt,rsg,rem,xu,xd,xs,xc,xb,xt
      real *8 RSGG1,RSpQCD,RS331,RS33pQCD,RS33
      real *8 pi1,ALINP1,EINP1,MTOP1,IOR1,NF2
      real *8 ALSx,ESTx,ESYx,MZINPx,MTOPx,NFx,IORx,ICHKx,HSR
      real *8 pi2,ALINP2,EINP2,MTOP2
      common /inp/pi2,ALINP2,EINP2,MTOP2
      common /int/FTQ,IOR,NF,ICHK
      common /quama/mq,mp,th
      common /quaer/ERALS,IER
      common /alpha/mu,alpha
      common /input/muinp,mp4inp,mp5inp  ! error handling renscale,cmass,bmass
      common /results/Rvec,Raxi,Rqed
      common /rhadparts/ru1,rd1,rs1,rc,rb,rt,rsg,rem
      common /rhadnfmin1/Rless,NFext1,nf1
      common/var1/pi,ALINP,ERRAL,EINP,MTOP
      COMMON/QCDPA/ALSx,ESTx,ESYx,MZINPx,MTOPx,NFx,IORx,ICHKx ! global INPUT from main
      common/pqcdHS/pi1,ALINP1,EINP1,MTOP1,IOR1,NF2 ! local input for Rhad HS etc
      common /alphastrong/sqrts,api
      external RSpQCD,RS33pQCD,RS
      xu=0.375d0
      xd=0.750d0
      xs=xd
      xb=xd
      xc=xu
      xt=xu
      pi1=pi
      ALINP1=ALINP
      EINP1 =EINP 
      MTOP1 =MTOP 
      IOR1  =IOR  
      NF2   =NF
      ALSx  =ALINP
      ESTx  =0.d0
      ESYx  =ERRAL
      MZINPx=EINP
      MTOPx =MTOP
      NFx   =NF
      IORx  =IOR
      ICHKx =2
      pi2   =pi
      ALINP2=ALINP
      EINP2 =EINP
      MTOP2 =MTOP         
      N= 180
c      N=2
      FTQ=2
      IOR=3
      ICHK=2
      iord=IOR+1
      ICHK=1
      if (ICHK.EQ.1) write (*,*) ' Using my CHK version of rqcd' 
c
      call rqcdparam()
      call constants_qcd()
c
c Harlander Steinhauser plot parameter errors
c
      massc      = mq(4)        ! charm
      massb      = mq(5)        ! bottom
      masst      = mq(6)        ! top
      
      write (1,*) ' Input MSbar masses at 2 GeV:',massc,massb,masst
      
      mu        = 2.d0
      
      dummy=RS(mu*mu)

      write (1,*) ' renormalization scale mu:',mu
      
      call mms2mos(massc,4,iord,mc)
      call mms2mos(massb,5,iord,mb)
      call mms2mos(masst,6,iord,mt)
      
      write (1,*) ' Output pole masses:',mc,mb,mt

      mcin(1)=mp(4)
      mcin(2)=mp(4)-0.17d0
      mcin(3)=mp(4)+0.17d0
      mbin(1)=mp(5)
      mbin(2)=mp(5)-0.29d0
      mbin(3)=mp(5)+0.29d0
c
      write (*,*) ' NF=',NF
      do I=1,3 
         write(I,*) '     8.0000 '
         write(I,*) '     1.0000 '
         write(I,*) '   ',FLOAT(N+1)
         write(I,*) FTQ,IOR,NF,ICHK
         write(I,*) ALINP,EINP,MTOP
         write(I,*) mq
         write(I,*) mp
         write(I,*) th
         write(I,*) ' created with test_rqcdHS on ../for/vap/',
     &        ' output in fort.1'
      enddo
      write (2,*) ' e,rs33,RS331,Rvec/4.d0'
      write (3,*) ' e,RSGG1,Rless,RS331'
      write (4,*) ' e,alpha^-1'
c
c      e0=3.2d0
c      e0=1.2d0
c      de=0.5d0
c      e=e0-de        
c log scale
c      le0=dlog(1.2d0)
c      le1=dlog(220.d0)
c      dle=(le1-le0)/N
c      le=le0-dle
C R compilation high energy region
      emin=2.5d0
c      emin=13.0000d0
c      emax=25.2000d0
c      emin=01.8d0
c      emax=05.1d0
      emax=13.d0
      emin=EINP
      emax=MTOP
      n=2
      de=(emax-emin)/n
      do i=1,N+1 
         r(2)=6.d0
         r(3)=0.d0
c         if (e.gt.3.1d0) de=1.d0
c         if (e.gt.9.6d0) de=2.d0
c         if (e.gt.80.d0) de=10.d0
c         le=le+dle
c         e=dexp(le)
         e=emin+de*(i-1)
         s=e*e
         muin(1)=e
         muin(2)=e*2.d0
         muin(3)=e/2.d0
         do imu=1,3 
            muinp=muin(imu)
            do imc=1,3 
               mp4inp=mcin(imc)
               do imb=1,3 
                  mp5inp=mbin(imb)
                  do j=1,3    
                     IER=j
                     rx=rs(s)
c          als(j)=alpha
                     if ((imu.eq.1).and.(imc.eq.1).and.(imb.eq.1).and.
     &                    (ier.eq.1)) r(1)=rx
                     r(2)=dmin1(r(2),rx)
                     r(3)=dmax1(r(3),rx)
                  enddo
               enddo
            enddo
         enddo
c         write (1,124) e,als
         write (1,124) e,r
         IER=1
c         write (*,*) e,RSpQCD(s,IER)
         NFext=6
         do while ((NFext.gt.3).AND.(E.lt.th(NFext)))
            NFext=NFext-1
         enddo
         call rqcdHS(s,HSR,ALINP,EINP,MTOP,IOR,NF)
c         write (*,*) ' rqcdHS pars:',ALINP,EINP,MTOP,IOR,NF
c         write (*,*) ' e,HSR:',e,HSR,Rless
         RSGG1=HSR
         RS331=RS33pQCD(s,IER)
c            write (*,*) ' R33dat:',E,RSGG1,RS331,Rless,NFext1
c         IF (IER.EQ.1) THEN
            if (NFext.eq.3) then
               RS33=0.5d0*RSGG1
            else if (NFext.eq.4) then
               RS33=(RSGG1-Rless)*xc+RS331-xc*rc
            else if (NFext.eq.5) then
               RS33=(RSGG1-Rless)*xb+RS331-xb*rb
            else if (NFext.ge.6) then
               RS33=(RSGG1-Rless)*xt+RS331-xt*rt
            endif
c         ELSE
c            RS33=RS40(s,IER)*RS331/RSGG1
c         ENDIF
            dummy=RS(s)
            alpha_s=api*pi
            write (2,124) e,rs33,RS331,Rvec/4.d0
            write (3,124) e,RSGG1,Rless,RS331
            write (4,124) e,sqrts,alpha_s,alpha
         enddo
124   format(1x,1pe13.6,3(2x,1pe13.6))
      stop
      end

      function RS(S)
      implicit none
      integer i,FTQ,IOR,IOR1,NF,ICHK,IER
      integer loops, nf1, R2, R4
      real *8 S,e,R,RS,PI,ALINP,ERALS,EINP,MTOP,alps
      real *8 mq(6),mp(6),th(6)
      real *8 ARUN, alpha0, mu0, mu1, Mth(6), muth(6)
      real *8 Rpt, sqrts, alpha, rv
      common /inp/pi,ALINP,EINP,MTOP
      common /int/FTQ,IOR,NF,ICHK
      common /quama/mq,mp,th
      common /quaer/ERALS,IER
      common /alpha/mu1,alpha
c
      e=sqrt(s)
      call getnf(e,nf)
c      alps = ARUN ( alinp, einp, mp, th, e, ior, nf )
      alpha0=alinp
      if (IER.eq.2) alpha0=alinp-ERALS 
      if (IER.eq.3) alpha0=alinp+ERALS 
c      write (*,*) ' alinp,alpha0,nf',alinp,alpha0,nf
      if (ICHK.EQ.0) then
         call rqcd3(S,R,alpha0,EINP,MTOP,FTQ,IOR,NF) 
      else if (ICHK.EQ.1) then
         call rqcd3mn(s,R,alpha0,EINP,MTOP,FTQ,IOR,NF)
      else if (ICHK.EQ.2) then
c        call rqcd3mn(s,R,ALINP,EINP,MTOP,FTQ,IOR,NF)
        call rqcdHS(s,R,alpha0,EINP,MTOP,IOR,NF)
      else
      endif
c  Given: 
c       alpha0(mu0) --- initial value at reference point
c       mu0         --- reference point
c       Mth(1:6)    --- array of thresholds (in On-Shell scheme) 
c       muth(1:6)   --- array of decoupling scales
c       mu1         --- new point
c       loops       --- number of loops (1,2,3,4) 
c       
         do i=1,6 
           Mth(i)  = mp(i)
           muth(i) = th(i)
         enddo
         sqrts=sqrt(s)
         alpha0=alinp
         if (IER.eq.2) alpha0=alinp-ERALS 
         if (IER.eq.3) alpha0=alinp+ERALS 
         mu0   =einp
         loops =ior
         mu1   =sqrts
         alpha = ARUN ( alpha0, mu0, Mth, muth, mu1, loops, nf1 )
         write (*,*) ' RS: alpha fro ARUN ',alpha
c  Arguments:
c     sqrts = sqrt(s)  (in GeV)
c             must be > 10.0 GeV
c     alpha = alpha(s)
c             note that mu=s in the following
c             therefore alpha should be taken as alpha(s)
c     loops = 1,...,4
c             1 correspond to parton model (no QCD corr.)
c             4 QCD corr. to O(alpha^3)
c
c      R2, R4 = 0 or 1
c        we have further two parameter R2 and R4 to 
c        swich on/off mm and mm^2 corections correspondingly.
c        r2=1
c        r4=1
cc        R =Rpt( sqrts, alpha, loops, R2, R4 )
c      RS=R
      return
      end
