      subroutine rqcdparam()
c Input parameters for R(s) routines
      implicit none
      integer i,j,IER
      double precision pi,ALINP,ERRAL,EINP,MTOP
      real *8 PI1,ALINP1,ERALS,EINP1,MTOP1
      REAL *8 MQ0(6),MP0(6),TH0(6),DMP0(6,3)
      REAL *8 MQ1(6),MP1(6),TH1(6),DMP1(6,3)
      common/var1/pi,ALINP,ERRAL,EINP,MTOP
      common /quama/mq0,mp0,th0
      common /quame/dmp0
      common /inp/pi1,ALINP1,EINP1,MTOP1
      common /QUARK/MQ1,MP1,TH1
      common /QUAER/ERALS,IER

      call constants_qcd()

      PI1=PI
      ALINP1=ALINP
      ERALS=ERRAL
      EINP1=EINP
      MTOP1=MTOP
      do i=1,6 
         MQ1(i)=MQ0(i)
         MP1(i)=MP0(i)
         TH1(i)=TH0(i)
         do j=1,3
            DMP1(i,j)=DMP0(i,j)
         enddo 
      enddo
c
      RETURN
      END
c      subroutine rqcdparam()
cc Input parameters for R(s) routines
c      implicit none
c      integer i,j,IER,INI
c      real *8 PI,ALINP,ERALS,EINP,MTOP
c      REAL *8 MQ0(6),MP0(6),TH0(6),DMP0(6,3)
c      REAL *8 MQ1(6),MP1(6),TH1(6),DMP1(6,3)
c      common /inp/pi,ALINP,EINP,MTOP
c      common /QUAMA/mq0,mp0,th0
c      common /QUARK/MQ1,MP1,TH1
c      common /QUAME/DMP1
c      common /QUAER/ERALS,IER
c      data pi /3.141592653589793d0/
c      data ini/0/
cc Updated 08/04/2008 for Frascati meeting
cc MQ: m_c(m_c)= 1.2 GeV etc.
cc      DATA MQ0 /0.005D0,0.009D0,0.190D0,1.20D0,3.97D0,165.D0/
cc      DATA MP0 /0.005D0,0.009D0,0.190D0,1.65D0,4.75D0,175.D0/
cc      DATA TH0 /1.8D0,1.8D0,1.8D0,3.7D0,10.4D0,350.D0/
cC CDF and D0 ) 0808.1089 [hep-ex] M_t = 172.4 +/- 0.7 (stat.) +/- 1.0 (syst.) GeV/c^2, 
cc update aug 2008 Kuhn, Steinhauser, Sturm NPB 778 (2007) 192
c      DATA MQ0 /0.005D0,0.009D0,0.190D0,1.286D0,4.164D0,163.4D0/
c      DATA MP0 /0.005D0,0.009D0,0.190D0,1.666D0,4.800D0,171.3D0/
cc      DATA MP0 /0.005D0,0.009D0,0.190D0,1.65D0,4.750D0,174.2D0/
cc      DATA TH0 /1.4D0,1.4D0,1.4D0,3.1D0,9.46D0,345.D0/
cc      thrc = 4.8d0,thrb = 11.2d0,thrt = 2*masst+10.d0 in accordance with H&S rhad
c      DATA TH0 /1.8D0,1.8D0,1.8D0,4.8D0,11.2D0,352.6D0/
c      DATA DMP0/0.000D0,0.000D0,0.000D0,0.00D0,0.00D0,000.D0,
c     &         0.000D0,0.000D0,0.000D0,-.017D0,-.029D0,-01.4D0,
c     &         0.000D0,0.000D0,0.000D0,0.017D0,0.029D0,001.4D0/
cC
c      save
cC
cc      ALINP= 0.1187d0       ! alpha strong at M_Z
cc      EINP = 91.19d0       ! M_Z Z boson mass
cc      ERALS= 0.0027d0
cC update S. Bethke June 2006
cc      alinp= 0.1189d0
cc Davier Aleph at tau
cc      alinp=0.334
cc LEP Z withs final
c      alinp= 0.1191d0  ! +/- 0.0027
ccc Davier's Tau Aleph result 2007
cc      alinp= 0.1212d0  ! +/- 0.0011
cc
c      einp =91.1876d0
cc      einp=1.7771d0
cc Bethke 2006
cc      erals= 0.002d0
cc      erals=0.009d0
ccc LEP Z withs final 
c      erals= 0.0027d0
ccc Davier's tau value
cc      erals= 0.009d0
c      if (ini.eq.0) then
c         write (*,*) ' rqcd-param.f: Using:',
c     &        ' Davier s Tau result ',alinp,erals
c         ini=1
c      endif 
c      MTOP = mp0(6)
c      do i=1,6 
c         MQ1(i)=MQ0(i)
c         MP1(i)=MP0(i)
c         TH1(i)=TH0(i)
c         do j=1,3
c            DMP1(i,j)=DMP0(i,j)
c         enddo 
c      enddo
cc
c      RETURN
c      END
